Distribution:	CCux
Packager:	Christian Metzen <metzench@ccux-linux.de>

Summary:	udev - a userspace implementation of devfs
Name:		udev
Version:	146
Release:	3
Epoch:		1
Provides:	udev
License:	GNU/GPL
Group:		System/Configuration/Hardware
Source0:	ftp://ftp.kernel.org/pub/linux/utils/kernel/hotplug/%{name}-%{version}.tar.bz2
Source201:	start_udev
Source202:	udev.nodes
Source203:	udev-post.init
Source204:	fw_unit_symlinks.sh
Source205:	udev-ccux-default-rules.tar.bz2
Source207:	udev.sysconfig
Patch1:		udev-137-alsa.patch
Patch2:		udev-120-nettype.patch
Patch4:		udev-146-cd.patch
Patch5: 	udev-118-sysconf.patch
URL:		http://kernel.org/pub/linux/utils/kernel/hotplug/
BuildRoot:	%{_tmppath}/%{name}-buildroot
BuildRequires:	sed
BuildRequires:	flex
BuildRequires:	pam-devel
BuildRequires:	bison
BuildRequires:	usbutils
Buildrequires:	gobject-introspection-devel
Prereq:		MAKEDEV
Requires:	MAKEDEV
Requires:	sed
Requires:	ccux-bootscripts >= 1:0.9.9-7

#AutoProv:	no
#AutoReq:	no

%define 	debug false
%define 	udev_scriptdir /lib/udev
%define 	firmwaredir /lib/firmware

#Automatically resolved build dependencies
BuildRequires: glibc-devel
BuildRequires: glib-devel
BuildRequires: libacl-devel
BuildRequires: libusb-devel
BuildRequires: pkg-config

%description
The udev package contains an implementation of devfs in 
userspace using sysfs and netlink.

%package -n libudev
Summary: Dynamic library to access udev device information
Group: System Environment/Libraries
# ensure upgrade path
Obsoletes: libudev0 <= 1:142
Provides: libudev0 = %{epoch}:%{version}

%description -n libudev
This package contains the dynamic library libudev, which provides access
to udev device information, and an interface to search devices in sysfs.

%package -n libudev-devel
Summary: Development files for libudev
Group: Development/Libraries
Requires: udev = %{epoch}:%{version}-%{release}
Requires: libudev = %{epoch}:%{version}-%{release}

%description -n libudev-devel
This package contains the development files for the library libudev, a
dynamic library, which provides access to udev device information.

%package -n libgudev1
Summary: Libraries for adding libudev support to applications that use glib
Group: Development/Libraries
Requires: libudev >= %{epoch}:%{version}-%{release}

%description -n libgudev1
This package contains the libraries that make it easier to use libudev
functionality from applications that use glib.

%package -n libgudev1-devel
Summary: Header files for adding libudev support to applications that use glib
Group: Development/Libraries
Requires: libudev-devel >= %{epoch}:%{version}-%{release}
Requires: libgudev1 = %{epoch}:%{version}-%{release}

%description -n libgudev1-devel
This package contains the header and pkg-config files for developing
glib-based applications using libudev functionality.


%prep
%setup -q
tar xvfj %{SOURCE205}
%patch1 -p1 -b .alsa
%patch2 -p1 -b .nettype
%patch4 -p1 -b .cd
%patch5 -p1

%build
# get rid of rpath
libtoolize -f -c
./configure \
--prefix=%{_prefix} \
--sysconfdir=%{_sysconfdir} \
--sbindir="/sbin" \
--libexecdir=%{udev_scriptdir} \
--with-rootlibdir=/lib \
--enable-introspection
make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{_sbindir}

make install DESTDIR=$RPM_BUILD_ROOT

rm -fr $RPM_BUILD_ROOT%{_docdir}/udev
rm -f $RPM_BUILD_ROOT/%{_libdir}/*.la

# Deprecated, but keep the ownership
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/udev/{rules.d,makedev.d,scripts,devices}
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/dev.d
mkdir -p $RPM_BUILD_ROOT%{_bindir}
touch $RPM_BUILD_ROOT%{_sysconfdir}/scsi_id.config

# force relative symlinks
ln -sf ..%{udev_scriptdir}/scsi_id $RPM_BUILD_ROOT/sbin/scsi_id

ln -sf ../../sbin/udevadm $RPM_BUILD_ROOT%{_bindir}/udevinfo
ln -sf ../../sbin/udevadm $RPM_BUILD_ROOT%{_bindir}/udevtest
ln -sf ../../sbin/udevadm $RPM_BUILD_ROOT%{_sbindir}/udevmonitor

ln -sf ../../sbin/udevadm $RPM_BUILD_ROOT/sbin/udevtrigger
ln -sf ../../sbin/udevadm $RPM_BUILD_ROOT/sbin/udevsettle
ln -sf ../../sbin/udevadm $RPM_BUILD_ROOT/sbin/udevcontrol

for i in \
	etc/udev/ccux/40-ccux.rules \
	etc/udev/ccux/95-pam-console.rules \
%ifarch ia64
	rules/packages/40-ia64.rules \
%endif
	rules/packages/40-isdn.rules \
	rules/packages/40-alsa.rules \
	rules/packages/64-md-raid.rules \
	rules/packages/64-device-mapper.rules \
	; do
	install -m 0644 "$i"  "$RPM_BUILD_ROOT%{udev_scriptdir}/rules.d/${i##*/}"
done
	
mkdir -p $RPM_BUILD_ROOT%{udev_scriptdir}/{,devices}

install -m 0755 %{SOURCE204} $RPM_BUILD_ROOT%{udev_scriptdir}/fw_unit_symlinks.sh

mkdir -p $RPM_BUILD_ROOT%{_datadir}/udev
install -m 0755 %{SOURCE201} $RPM_BUILD_ROOT/sbin/start_udev

mkdir -p -m 0755 $RPM_BUILD_ROOT%{firmwaredir}

mkdir -p -m 0755 $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d
cat > $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/floppy-pnp.conf <<EOF
alias pnp:dPNP0700 floppy
alias acpi:PNP0700: floppy
EOF

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d
install -m 0755 %{SOURCE203} $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d/udev-post

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig
install -m 0755 %{SOURCE207} $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/udev

mkdir -p $RPM_BUILD_ROOT/var/lib/udev/makedev.d

%preun
if [ "$1" -eq 0 -a -f %{_initrddir}/udev ]; then
	if [ -x /sbin/pidof ]; then
		pid=$(/sbin/pidof -c udevd)
		if [ -n "$pid" ]; then
			kill $pid
		fi
	fi
	/sbin/chkconfig --del udev
fi
if [ "$1" -eq 0 ]; then
	/sbin/chkconfig --del udev-post
fi
exit 0

%pre
# to be removed in the near future 
getent group video >/dev/null || /usr/sbin/groupadd -g 39 video || :
getent group audio >/dev/null || /usr/sbin/groupadd -g 11 audio || :
# to be kept
getent group cdrom >/dev/null || /usr/sbin/groupadd -g 63 cdrom || :
getent group tape >/dev/null || /usr/sbin/groupadd -g 33 tape || :
getent group dialout >/dev/null || /usr/sbin/groupadd -g 18 dialout || :

# kill daemon if we are not in a chroot
if test -f /proc/1/exe -a -d /proc/1/root; then
	if test -x /usr/bin/stat -a "$(/usr/bin/stat -Lc '%%D-%%i' /)" = "$(/usr/bin/stat -Lc '%%D-%%i' /proc/1/root)"; then
		if test -x /sbin/udevd -a -x /sbin/pidof ; then
			/sbin/udevadm control --stop-exec-queue
			pid=$(/sbin/pidof -c udevd)
			while [ -n "$pid" ]; do
				for p in $pid; do
					kill $hard $p;
				done
				pid=$(/sbin/pidof -c udevd)
				hard="-9"
			done
		fi
	fi
fi
exit 0

%post
# start daemon if we are not in a chroot
if test -f /proc/1/exe -a -d /proc/1/root; then
	if test "$(/usr/bin/stat -Lc '%%D-%%i' /)" = "$(/usr/bin/stat -Lc '%%D-%%i' /proc/1/root)"; then
		/sbin/udevd -d
		/sbin/udevadm control --start-exec-queue
	fi
fi
/sbin/chkconfig --add udev-post

exit 0

%triggerin -- MAKEDEV
rm -f /var/lib/udev/makenode.d/*  >/dev/null 2>&1 || :

%post -n libudev -p /sbin/ldconfig
%postun -n libudev -p /sbin/ldconfig

%post -n libgudev1 -p /sbin/ldconfig
%postun -n libgudev1 -p /sbin/ldconfig

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(0644, root, root, 0755)
%doc COPYING README TODO ChangeLog docs/* extras/keymap/README.keymap.txt
%attr(0755,root,root) /sbin/udevadm
%attr(0755,root,root) /sbin/udevsettle
%attr(0755,root,root) /sbin/udevtrigger
%attr(0755,root,root) /sbin/udevcontrol
%attr(0755,root,root) /sbin/udevd
%attr(0755,root,root) /sbin/start_udev
%attr(0755,root,root) /sbin/scsi_id
%attr(0755,root,root) %{udev_scriptdir}/scsi_id
%attr(0755,root,root) %{udev_scriptdir}/ata_id
%attr(0755,root,root) %{udev_scriptdir}/edd_id
%attr(0755,root,root) %{udev_scriptdir}/usb_id
%attr(0755,root,root) %{udev_scriptdir}/cdrom_id
%attr(0755,root,root) %{udev_scriptdir}/path_id
%attr(0755,root,root) %{udev_scriptdir}/hid2hci
%attr(0755,root,root) %{udev_scriptdir}/create_floppy_devices
%attr(0755,root,root) %{udev_scriptdir}/fw_unit_symlinks.sh
%attr(0755,root,root) %{udev_scriptdir}/firmware.sh
%attr(0644,root,root) %{udev_scriptdir}/rule_generator.functions
%attr(0755,root,root) %{udev_scriptdir}/write_cd_rules
%attr(0755,root,root) %{udev_scriptdir}/write_net_rules
%attr(0755,root,root) %{udev_scriptdir}/collect
%attr(0755,root,root) %{udev_scriptdir}/fstab_import

%attr(0755,root,root) %dir %{udev_scriptdir}/rules.d/
%attr(0755,root,root) %{_sysconfdir}/rc.d/init.d/udev-post
%attr(0755,root,root) %{_bindir}/udevtest
%attr(0755,root,root) %{_bindir}/udevinfo
%attr(0755,root,root) %{_sbindir}/udevmonitor
%attr(0755,root,root) %dir %{_sysconfdir}/udev/
%attr(0755,root,root) %dir %{_sysconfdir}/udev/rules.d/
%attr(0755,root,root) %dir %{udev_scriptdir}/
%attr(0755,root,root) %dir %{udev_scriptdir}/devices/
%attr(0755,root,root) %dir %{_sysconfdir}/udev/makedev.d/

%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/sysconfig/udev

%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/udev/udev.conf
%attr(0644,root,root) %{udev_scriptdir}/rules.d/*.rules

%ghost %config(noreplace,missingok) %attr(0644,root,root) %{_sysconfdir}/scsi_id.config

%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/modprobe.d/floppy-pnp.conf

%dir %attr(0755,root,root) %{firmwaredir}
%attr(0644,root,root) %{_mandir}/man8/udev*.8*
%attr(0644,root,root) %{_mandir}/man7/udev*.7*
%attr(0644,root,root) %{_mandir}/man8/scsi_id*.8*

%dir %attr(0755,root,root) /var/lib/udev
%dir %attr(0755,root,root) /var/lib/udev/makedev.d

# GObject introspection
%{_libdir}/girepository-1.0/GUdev-1.0.typelib
%{_datadir}/gir-1.0/GUdev-1.0.gir

# Deprecated, but keep the ownership
%ghost %dir %{_sysconfdir}/udev/scripts/
%ghost %dir %{_sysconfdir}/udev/devices/
%ghost %dir %{_sysconfdir}/dev.d/

%attr(0755,root,root) %{udev_scriptdir}/modem-modeswitch
%attr(0755,root,root) %{udev_scriptdir}/pci-db
%attr(0755,root,root) %{udev_scriptdir}/usb-db
%attr(0755,root,root) %{udev_scriptdir}/keymap
%attr(0755,root,root) %{udev_scriptdir}/udev-acl
%attr(0755,root,root) %{udev_scriptdir}/v4l_id
%attr(0755,root,root) %{udev_scriptdir}/findkeyboards
%attr(0644,root,root) %{udev_scriptdir}/keymaps/*
%attr(0644,root,root) %{_prefix}/lib/ConsoleKit/run-session.d/udev-acl.ck


%files -n libudev
%defattr(0644, root, root, 0755)
%doc COPYING
%attr(0755,root,root) /%{_lib}/libudev.so.*

%files -n libudev-devel
%defattr(0644, root, root, 0755)
%doc COPYING
%{_includedir}/libudev.h
%{_libdir}/libudev.so
%{_libdir}/pkgconfig/libudev.pc
%{_datadir}/pkgconfig/udev.pc
%{_datadir}/gtk-doc/html/libudev/*

%files -n libgudev1
%defattr(0644, root, root, 0755)
%doc COPYING
%attr(0755,root,root) %{_libdir}/libgudev-1.0.so.*
#%attr(0644,root,root) %{_libdir}/girepository-1.0/GUdev-1.0.typelib

%files -n libgudev1-devel
%defattr(0644, root, root, 0755)
%doc COPYING
%attr(0755,root,root) %{_libdir}/libgudev-1.0.so
%attr(0644,root,root) %{_includedir}/gudev-1.0/gudev/*.h
#%attr(0644,root,root) %{_datadir}/gir-1.0/GUdev-1.0.gir
%dir %{_datadir}/gtk-doc/html/gudev
%attr(0644,root,root) %{_datadir}/gtk-doc/html/gudev/*
%attr(0644,root,root) %{_libdir}/pkgconfig/gudev-1.0*

%changelog
* Sun Jan 10 2010 Christian Wasem <wasem@ccux-linux.de> 1:146-3
- removed rpm as a require
* Mon Nov 23 2009 Karsten Brockmann <arcam@ccux-linux.de> 1:146-2
- fixed initscripts
- enabled GObject introspection
- udev 147 won`t build until we update glibc
* Wed Sep 02 2009 Karsten Brockmann <arcam@ccux-linux.de> 1:146-1
- Version update
* Thu Apr 16 2009 Karsten Brockmann <arcam@ccux-linux.de> 1:141-1
- Version update
* Tue Mar 24 2009 Christian Metzen <metzench@ccux-linux.de> 1:140-2
- fixed requires for libudev0-devel
* Fri Mar 20 2009 Christian Metzen <metzench@ccux-linux.de> 1:140-1
- Version update
* Thu Mar 05 2009 Christian Metzen <metzench@ccux-linux.de> 1:139-3
- readded missed lines from merging ( floppy-pnp.conf )
* Wed Mar 04 2009 Christian Metzen <metzench@ccux-linux.de> 1:139-2
- merge latest and new layout packages
* Wed Mar 04 2009 Karsten Brockmann <arcam@ccux-linux.de> 1:139-1
- version update
* Tue Feb 24 2009 Karsten Brockmann <arcam@ccux-linux.de> 1:138-1
- version update
* Tue Feb 17 2009 Karsten Brockmann <arcam@ccux-linux.de> 1:137-1
- version update
* Mon Jan 05 2009 Christian Metzen <metzench@ccux-linux.de> 1:135-4
- remove old sysvinit script only start_udev is needed
* Mon Jan 05 2009 Christian Metzen <metzench@ccux-linux.de> 1:135-3
- add libudev subpackages
* Mon Jan 05 2009 Christian Metzen <metzench@ccux-linux.de> 1:135-2
- removed scriplet error
- updated dvb permissions, fixes bug FS#52
* Mon Jan 05 2009 Christian Metzen <metzench@ccux-linux.de> 1:135-1
- Version update
* Fri Jul 25 2008 Karsten Brockmann <arcam@ccux-linux.de> 1:125-1
- Version update
* Mon Jun 30 2008 Christian Metzen <metzench@ccux-linux.de> 1:124-2
- added patch to be able to write cds and dvds again
* Mon Jun 23 2008 Christian Wasem <wasem@ccux-linux.de> 1:124-1
- Version update
* Sun Jun 01 2008 Karsten Brockmann <arcam@ccux-linux.de> 1:122-1
- Version update
* Fri Apr 11 2008 Christian Wasem <wasem@ccux-linux.de> 1:120-1
- cleaned specfile, added ccux-default-distro.tar.bz2
* Fri Mar 28 2008 Christian Wasem <wasem@ccux-linux.de> 1:119-2
- added default-rules.patch
* Mon Mar 24 2008 Christian Wasem <wasem@ccux-linux.de> 1:119-1
- version update
* Tue Mar 18 2008 Christian Wasem <wasem@ccux-linux.de> 1:118-2
- rebuild, renamed redhat.rules to ccux.rules
* Fri Dec 21 2007 Karsten Brockmann <arcam@ccux-linux.de> 1:118-1
- Version update
* Mon Nov 26 2007 Christian Metzen <metzench@ccux-linux.de> 1:116-5
- fixed double rules file
* Mon Nov 26 2007 Christian Metzen <metzench@ccux-linux.de> 1:116-4
- rules patch
* Mon Nov 26 2007 Christian Metzen <metzench@ccux-linux.de> 1:116-3
- alsa rules / fixed permissions
* Mon Nov 26 2007 Christian Metzen <metzench@ccux-linux.de> 1:116-2
- fixed post script
* Mon Nov 26 2007 Christian Metzen <metzench@ccux-linux.de> 1:116-1
- Version update
* Sat Feb 10 2007 Karsten Brockmann <arcam@ccux-linux.de> 1:105-1
- Version update
* Tue Jan 23 2007 Christian Metzen <metzench@ccux-linux.de> 1:104-4
- small patch adjustment
* Tue Jan 23 2007 Christian Metzen <metzench@ccux-linux.de> 1:104-3
- readded WAIT_FOR_SYSFS
* Sat Jan 20 2007 Karsten Brockmann <arcam@ccux-linux.de> 1:104-2
- removed deprecated WAIT_FOR_SYSFS from 05-early-rules
* Mon Jan 15 2007 Karsten Brockmann <arcam@ccux-linux.de> 1:104-1
- Version update
* Fri Oct 27 2006 Christian Metzen <metzench@ccux-linux.de> 1:103-2
- modified ccux rules patch
* Sun Oct 22 2006 Karsten Brockmann <arcam@ccux-linux.de> 1:103-1
- Version update
- adapted rules to fit Kernel 2.6.18
* Wed Oct 03 2006 Christian Metzen <metzench@ccux-linux.de> 1:100-3
- downgrade 
* Sun Oct 01 2006 Christian Metzen <metzench@ccux-linux.de> 101-1
- Version update
* Wed Sep 27 2006 Christian Metzen <metzench@ccux-linux.de> 100-2
- fixed initscript
* Wed Sep 27 2006 Christian Metzen <metzench@ccux-linux.de> 100-1
- Version update
* Wed Sep 27 2006 Christian Metzen <metzench@ccux-linux.de> 095-1
- Version update
* Fri Aug 04 2006 Karsten Brockmann <arcam@ccux-linux.de> 079-4
- Modified rules file (added Mode 0660 for cd/dvd-writer devices)
* Sat Apr 22 2006 Christian Metzen <metzench@ccux-linux.de> 079-3
- Modified rules file
* Sat Jan 07 2006 Christian Metzen <metzench@ccux-linux.de> 079-2
- Added some requires for cleaner updates
* Thu Jan 05 2006 Christian Metzen <metzench@ccux-linux.de> 079-1
- Version update
* Thu Jan 05 2006 Christian Metzen <metzench@ccux-linux.de> 078-4
- Modified startup Script
* Mon Jan 02 2006 Christian Metzen <metzench@ccux-linux.de> 078-3
- Modified startup Script
* Mon Jan 02 2006 Christian Metzen <metzench@ccux-linux.de> 078-2
- Modified startup Script
* Mon Dec 26 2005 Christian Metzen <metzench@ccux-linux.de> 078-1
- Version update, changed build process
* Sun Sep 04 2005 Christian Metzen <metzench@ccux-linux.de> 068-1
- Version update
* Sat Jul 02 2005 Christian Metzen <metzench@ccux-linux.de> 059-1
- Version update to 059
* Mon May 23 2005 Karsten Brockmann <brockmka@rz.fh-augsburg.de> 058-1
- Version Update to 058
* Sat May 14 2005 Christian Metzen <metzench@ccux-linux.de> 057-1
- Version Update to 057
* Fri Mar 25 2005 Christian Metzen <metzench@ccux-linux.de> 056-1
- Version Update to 056
* Wed Feb 16 2005 Christian Metzen <metzench@ccux-linux.de> 053-3
- Fixed Permissions for removable Devices
* Mon Feb 14 2005 Christian Metzen <metzench@ccux-linux.de> 053-2
- Updated to new Layout Schema
* Mon Feb 14 2005 Christian Metzen <metzench@ccux-linux.de> 053-1
- Version Update to 053
* Wed Jan 19 2005 Christian Metzen <metzench@ccux-linux.de> 050-2
- Fixed Minor Bug
* Wed Jan 19 2005 Christian Metzen <metzench@ccux-linux.de> 050-1
- Version Update to 050
* Fri Nov 19 2004 Christian Metzen <metzench@ccux-linux.de> 046-1
- Initial Release
